#!/usr/bin/env python3

import re, sys

def bp(l):
    return int(re.sub('[FL]', '0', re.sub('[BR]', '1', l)), base=2)

fn = sys.argv[1] if len(sys.argv) > 1 else 'input5'
with open(fn) as f:

    lines = [l.strip() for l in f.readlines()]
    sl = sorted(bp(l) for l in lines)
    print(sl[-1])
    print(next(a+1 for a, b in zip(sl, sl[1:]) if a + 1 != b))
